#include <iostream>
#include <fstream>
#include <iomanip>

template <typename T>
class Matr {
public:
	Matr() : n {0}, m{0}, ptr {nullptr}
	{}
// =========== RAII ===================
	Matr(int n, int m, const T& v = T()) : 
		n {n}, m {m}
	{
		AlocRes();
		FillMatr(v);
	}
	
	// Copy Constructor
	Matr(const Matr& a) : n {a.n}, m {a.m}
	{
		AlocRes();
		CopyVal(a);
		i = a.i; j = a.j;
	}
	
	Matr& operator = (const Matr& a)
	{
		if (this == &a) return *this;
		DezalocRes();
		n = a.n; m = a.m;
		i = a.i; j = a.j;
		AlocRes();
		CopyVal(a);
		
		return *this;
	}
	
	// Move Semnatics
	// Move Copy Contructor
	
	Matr(Matr&& a) : n {a.n}, m {a.m}, ptr {a.ptr}
	{
		i = a.i; j = a.j;
		
		// Lasam obiectul a intr-o stare consistenta
		a.n = a.m = a.j = a.i = 0;
		a.ptr = nullptr;
	}
	
	// Move Assignment Operator
	
	Matr& operator = (Matr&& a)
	{
		if (this == &a) return *this;
		
		DezalocRes();
		n = a.n; m = a.m;
		i = a.i; j = a.j;
		ptr = a.ptr;
		
		// Lasam obiectul a intr-o stare consistenta
		a.n = a.m = a.j = a.i = 0;
		a.ptr = nullptr;
		return *this;
	}
// ==============================================

	T*& operator [] (int index) const
	{
		return ptr[index];
	}
	
	friend std::istream& operator >> (std::istream& is, Matr& a)
	{
		if (a.ptr == nullptr)
			return is;
		return is >> a.ptr[a.i][a.j];
	}
	
	friend std::ostream& operator << (std::ostream& os, const Matr& a)
	{
		if (a.ptr == nullptr)
			return os;
		return os << a.ptr[a.i][a.j];
	}
	
	~Matr()
	{
		DezalocRes();
	}

private:
	void AlocRes()
	{
		ptr = new T*[n];
		for (int i = 0; i < n; ++i)
			ptr[i] = new T[m];
	}
	
	void DezalocRes()
	{
		if (ptr == nullptr) return;
		
		for (int i = 0; i < n; ++i) 
			delete[] ptr[i];
		delete[] ptr;
	}
	
	void FillMatr(const T& v)
	{
		if (ptr == nullptr)
			return;
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < m; ++j)
				ptr[i][j] = v;
	}
	
	void CopyVal(const Matr& a)
	{
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < m; ++j)
				ptr[i][j] = a.ptr[i][j];	
	}
	
	int i = 0, j = 0;
	int n, m;
	T* *ptr;
};

std::ifstream fin("matr.in");
std::ofstream fout("matr.out");

template <typename T>
void Print(const Matr<T>& a, int n, int m)
{
	for (int i = 0; i < n; ++i, fout << '\n')
		for (int j = 0; j < m; ++j)
			fout << std::setw(10) << a[i][j];
	fout << '\n';
}


int main()
{
	int n, m;
	/*
	fin >> n >> m;
	Matr<int> a(n, m);
	
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			fin >> a[i][j];
	
	Print(a, n, m);
	*/
	
	fin >> n >> m;
	Matr<std::string> b(n, m);
	
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			fin >> b[i][j];
	
	Print(b, n, m);
	
	Matr c {std::move(b)};
	Print(c, n, m);

	b = Matr<std::string>(10, 20, "Getuta");
	Print(b, 10, 20);
}
